<?php include('./templates/cabecera.php'); ?>
<?php include('./config/db.php'); ?>
<?php include('funciones.php'); ?>
<?php 
$html = "usuarios.php";
if(!$_GET){
    //header('Location: usuarios.php?pagina=1');
    echo "<script>location.href='$html?pagina=1';</script>";
}

if($_SESSION['perfil'] == 2){
    echo "<script>location.href='index.php?pagina=1';</script>";
}

$error = "";
$ok =(isset($_GET['ok']))?$_GET['ok']:"";
$txtFiltro=(isset($_GET['txtFiltro']))?$_GET['txtFiltro']:"";
$totalPaginas = 10;
$paginadorSalto = 9;
$txtId=(isset($_POST['txtId']))?$_POST['txtId']:"";
if(isset($_POST['chkActivo']) == "on"){
    $chkActivo = 1; //activo
}else{
    $chkActivo = 0; //inactivo
}
$selPerfil=(isset($_POST['selPerfil']))?$_POST['selPerfil']:"";
$txtRun=(isset($_POST['txtRun']))?$_POST['txtRun']:"";
$txtRun2=(isset($_POST['txtRun2']))?$_POST['txtRun2']:"";
$txtNomUsuario=(isset($_POST['txtNomUsuario']))?$_POST['txtNomUsuario']:"";
$txtApeUsuario=(isset($_POST['txtApeUsuario']))?$_POST['txtApeUsuario']:"";
$txtPassUsuario=(isset($_POST['txtPassUsuario']))?$_POST['txtPassUsuario']:"";
$txtPassUsuario2=(isset($_POST['txtPassUsuario2']))?$_POST['txtPassUsuario2']:"";

$action=(isset($_POST['action']))?$_POST['action']:"";

switch($action){
    case "Agregar":
        if(!validaRut($txtRun)){
            $error = $error."-Debe ingresar un RUN v&aacute;lido<br>";
        }else{
            try{
                $sql=$conexion->prepare("SELECT * FROM usuarios where run=:run;");  
                $sql->bindParam(":run",$txtRun);
                $sql->execute();
                if($sql->rowCount() > 0){
                    $error = $error."-El RUN ingresado ya se encuentra en nuestros registros<br>";
                }
            }catch (Exception $err) {
                echo ("Ha ocurrido un error en la solicitud. ");  
            }
        }
        if($txtPassUsuario != $txtPassUsuario2){
            $error = $error."-La contrase&ntilde;as ingresadas deben ser iguales<br>";
            $txtPassUsuario = "";
        }
        if($txtNomUsuario == ""){
            $error = $error."-Debe ingresar un nombre<br>";
        }
        if($txtApeUsuario == ""){
            $error = $error."-Debe ingresar un apellido<br>";
        }
        if(strlen($error) == 0){
            try{
                $txtPassUsuario = base64_encode($localBase."".$txtPassUsuario);
                $txtNomUsuario = limpiaHTML($txtNomUsuario);
                $txtApeUsuario = limpiaHTML($txtApeUsuario);
                $sql=$conexion->prepare("INSERT INTO usuarios (activo,perfil,run,nombres,apellidos,contrasenna) 
                VALUES (:activo,:perfil,:run,:nombre,:apellido,:pass);");  
                $sql->bindParam(":activo",$chkActivo);
                $sql->bindParam(":perfil",$selPerfil);
                $sql->bindParam(":run",$txtRun);
                $sql->bindParam(":nombre",$txtNomUsuario);
                $sql->bindParam(":apellido",$txtApeUsuario);
                $sql->bindParam(":pass",$txtPassUsuario);
                $sql->execute();
                echo("<script>alert('Se ha ingresado el registro satisfactoriamente');</script>");
                echo "<script>location.href='$html';</script>";
            }catch (Exception $err) {
                $error = ("Ha ocurrido un error al agregar la solicitud");    
                //throw $th;
            }
        }    
        break;
    case "Modificar":
        if(!validaRut($txtRun2)){
            $error = $error."-Debe ingresar un RUN v&aacute;lido<br>";
        }
        if($txtPassUsuario != $txtPassUsuario2){
            $error = $error."-La contrase&ntilde;as ingresadas deben ser iguales<br>";
            $txtPassUsuario = "";
        }
        if($txtNomUsuario == ""){
            $error = $error."-Debe ingresar un nombre<br>";
        }
        if($txtApeUsuario == ""){
            $error = $error."-Debe ingresar un apellido<br>";
        }
        
        if(strlen($error) == 0){
            try{
                $txtPassUsuario = base64_encode($localBase."".$txtPassUsuario);
                $txtNomUsuario = limpiaHTML($txtNomUsuario);
                $txtApeUsuario = limpiaHTML($txtApeUsuario);
                $sql=$conexion->prepare("UPDATE usuarios SET activo=:activo, perfil=:perfil, nombres=:nombre, 
                apellidos=:apellido, contrasenna=:pass where id=:id;");  
                $sql->bindParam(":id",$txtId);
                $sql->bindParam(":activo",$chkActivo);
                $sql->bindParam(":perfil",$selPerfil);
                $sql->bindParam(":nombre",$txtNomUsuario);
                $sql->bindParam(":apellido",$txtApeUsuario);
                $sql->bindParam(":pass",$txtPassUsuario);
                $sql->execute();
                echo("<script>alert('Se ha modificado el registro satisfactoriamente');</script>");
                echo "<script>location.href='$html';</script>";
            }catch (Exception $err) {
                $error = ("Ha ocurrido un error al modificar la solicitud");    
                //throw $th;
            }
        }
        break;
    case "Volver":
        //header("location:index.php");
        echo "<script>location.href='index.php';</script>";
        break;
    case "Seleccionar":
        try{
            $sql=$conexion->prepare("SELECT * FROM usuarios where id=:id;");  
            $sql->bindParam(":id",$txtId);
            $sql->execute();
            $Usuarios = $sql->fetch(PDO::FETCH_LAZY); //1 solo atributo, para trabajar con él
            $txtId= $Usuarios['id'];
            $chkActivo = $Usuarios['activo']; //0 - inactivo / 1 - activo
            $txtRun= $Usuarios['run'];
            $txtNomUsuario=$Usuarios['nombres'];
            $txtApeUsuario=$Usuarios['apellidos'];
            $txtPassUsuario=str_replace($localBase,"",base64_decode($Usuarios['contrasenna']));
            $selPerfil=$Usuarios['perfil'];
        }catch (Exception $err) {
            $error = ("Ha ocurrido un error al seleccionar el registro");    
            //throw $th;
        }
        break;
}

$sqlUsuarios="SELECT id, activo, perfil, run, nombres, 
apellidos, contrasenna FROM usuarios ";  
if($txtFiltro!="" ){
    $sqlUsuarios = $sqlUsuarios . " where run LIKE :id or nombres LIKE :id OR apellidos LIKE :id ";
}

try{
    $sql=$conexion->prepare($sqlUsuarios); 
    if($txtFiltro!="" ){
        $txtFiltro2=limpiaHTML("%".$txtFiltro."%");
        $sql->bindParam(":id",$txtFiltro2);
    }

    $sql->execute();
    if($sql->rowCount() > 0){
        $totalDatos = $sql->rowCount();
        $paginas = $totalDatos/$totalPaginas;
        $paginas = ceil($paginas);
    }else{
        $paginas = 1;
    }

}catch (Exception $err) {
    echo ("Ha ocurrido un error en la solicitud. ");   
}
if(is_null($_GET['pagina'])){
    $getPagina=0;
}else{
    $getPagina = intval($_GET['pagina']);
}

$iniciar = ($getPagina-1) * $totalPaginas;
$sqlUsuarios=$sqlUsuarios." ORDER BY id LIMIT :iniciar,:totalPaginas;";

try{
    $sql=$conexion->prepare($sqlUsuarios); 
    if($txtFiltro!="" ){
        $txtFiltro2=limpiaHTML("%".$txtFiltro."%");
        $sql->bindParam(":id",$txtFiltro2);
    }
    $sql->bindParam(":iniciar",$iniciar, PDO::PARAM_INT);
    $sql->bindParam(":totalPaginas",$totalPaginas, PDO::PARAM_INT);
    $sql->execute();
}catch (Exception $err) {
    echo ("Ha ocurrido un error en la solicitud. ");    
    throw $err;
}

$listaUsuarios = $sql->fetchAll(PDO::FETCH_ASSOC); //almacena todos los registros como arreglo
?>
<div class="col-md-4">
    <div class="card">
        <div class="card-header">
            <h4>Usuarios<h4/>
        </div>
        <div class="card-body">
                <?php if(strlen($error) > 0) {?>
                    <div class='alert alert-danger' role="alert">
                        <?php echo $error; ?>
                    </div>
                <?php }?>
            <form method="POST" enctype="multipart/form-data">
                <input type="hidden" class="form-control" name="txtId" id="txtId" value="<?php echo $txtId; ?>" >
                <div class="form-check form-switch">
                    <label for="chkActivo">Activo</label>
                    <input class="form-check-input" type="checkbox" id="chkActivo" name="chkActivo" <?php if($chkActivo == "1") {echo ("checked"); } ?>>
                </div>
                
                <div class = "form-group">
                    <label for="exampleSelect1" class="form-label mt-1">Perfil</label>
                    <select class="form-select" id="selPerfil" name="selPerfil" >
                    <?php
                    try{
                    $sqlPerfil=$conexion->prepare("SELECT id, detalle FROM perfil where activo=1;");  
                    $sqlPerfil->execute();
                    $listaPerfil = $sqlPerfil->fetchAll(PDO::FETCH_ASSOC); //almacena todos los registros como arreglo
                        foreach($listaPerfil as $per) { ?>
                            <option value="<?php echo $per['id'] ?>" <?php if($selPerfil==$per['id']) {echo ("selected"); } ?>><?php echo $per['detalle'] ?></option>
                        <?php 
                        } 
                    }catch (Exception $err) {
                        echo ("Ha ocurrido un error en la solicitud. ");    
                        throw $err;
                    }
                    ?>
                    </select>
                </div>
                <div class = "form-group">
                    <label for="exampleSelect1" class="form-label mt-1">RUN*</label>
                    <input type="text" required class="form-control" name="txtRun" id="txtRun" value="<?php echo $txtRun; ?>" placeholder="XXXXXXXX-X" <?php if ($action=="Seleccionar" ){echo ("disabled");} ?>>
                    <input type="hidden" name="txtRun2" id="txtRun2" value="<?php echo $txtRun; ?>">
                </div>
                <div class = "form-group">
                    <label for="exampleSelect1" class="form-label mt-1">Nombres*</label>
                    <input type="text" required class="form-control" name="txtNomUsuario" id="txtNomUsuario" value="<?php echo $txtNomUsuario; ?>">
                </div>
                <div class = "form-group">
                    <label for="exampleSelect1" class="form-label mt-1">Apellidos*</label>
                    <input type="text" required class="form-control" name="txtApeUsuario" id="txtApeUsuario" value="<?php echo $txtApeUsuario; ?>">
                </div>
                <div class = "form-group">
                    <label for="exampleSelect1" class="form-label mt-1">Contraseña*</label>
                    <input type="password" required class="form-control" name="txtPassUsuario" id="txtPassUsuario" value="<?php echo $txtPassUsuario; ?>">
                </div>
                <div class = "form-group">
                    <label for="exampleSelect1" class="form-label mt-1">Re-ingrese contraseña*</label>
                    <input type="password" required class="form-control" name="txtPassUsuario2" id="txtPassUsuario2" value="<?php echo $txtPassUsuario; ?>">
                </div>
                
                <br/>
                <div class="btn-group" role="group" aria-label="">
                    <button type="submit" name="action" <?php if ($action=="Seleccionar" or $action=="Modificar"  ){echo ("disabled");} ?> value="Agregar" class="btn btn-outline-success" onclick="return confirm('¿Está seguro de agregar el registro?')">Agregar</button> &nbsp;
                    <button type="submit" name="action" <?php if ($action!="Seleccionar" and $action!="Modificar"){echo ("disabled");} ?> value="Modificar" class="btn btn-outline-warning" onclick="return confirm('¿Está seguro de modificar el registro?')">Modificar</button>&nbsp;
                    <button type="submit" name="action" formnovalidate="" value="Volver" class="btn btn-outline-info">Volver</button>
                </div>
            </form>
        </div>
    </div>
</div>
<div class="col-md-8">
        <form class="d-flex" method="GET">
            <input type="hidden" class="form-control" name="pagina" id="pagina" value="<?php echo $getPagina; ?>" >
            <input class="form-control me-sm-2" type="text" placeholder="filtrar" name="txtFiltro" id="txtFiltro" value="<?php echo ($txtFiltro!="")?$txtFiltro:""; ?>">
            <button class="btn btn-outline-info" name="action" type="submit" value="Filtrar">Filtrar</button>
        </form>
    <table class="table table-hover">
        <thead>
            <tr>
                <th>ID</th>
                <th>RUN</th>
                <th>Nombres</th>
                <th>Apellidos</th>
                <th>Acci&oacute;n</th>
            </tr>
        </thead>
        <tbody>
            <?php 
            foreach($listaUsuarios as $usu) { ?>
            <tr>
                <td><?php echo $usu['id'] ?></td>
                <td><?php echo $usu['run'] ?></td>
                <td><?php echo $usu['nombres'] ?></td>
                <td><?php echo $usu['apellidos'] ?></td>
                <td>
                    <form method="post">
                        <input type="hidden" name="txtId"  value="<?php echo $usu['id'] ?>">
                        <!--input type="submit" name="action" value="Seleccionar" class="btn btn-outline-dark"-->
                        <!--i type="submit" class="bi-alarm" style="font-size: 2rem; color: cornflowerblue;"></i-->
                        <button type="submit" class="btn btn-outline-dark" name="action" value="Seleccionar">
                            <i type="submit" class="bi bi-check2-circle" style="font-size: 1rem; color: #BA0700;"></i>
                        </button>
                    </form>
                </td>
            </tr>
            <?php } ?>
        </tbody>
    </table>
    <div>
        <ul class="pagination">
            <li class="page-item <?php echo ($getPagina<=1)?"disabled":""; ?>">
                <a class="page-link" href="<?php echo $html; ?>?pagina=<?php echo $getPagina-1 ?>&txtFiltro=<?php echo $txtFiltro; ?>">&laquo;</a>
            </li>
            <?php for($i=0; $i< $paginas; $i++ ) { 
                    if((($i+1)%$paginadorSalto)==0){
                        echo("</ul><ul class='pagination'>");
                    } 
                ?>
            <li class="page-item <?php echo ($getPagina==$i+1)?"active":""; ?>">
                <a class="page-link" href="<?php echo $html; ?>?pagina=<?php echo $i+1 ?>&txtFiltro=<?php echo $txtFiltro; ?>"><?php echo $i+1 ?></a>
            </li>
            <?php } ?>
            <li class="page-item <?php echo ($getPagina>=$paginas)?"disabled":""; ?>">
                <a class="page-link" href="<?php echo $html; ?>?pagina=<?php echo $getPagina+1 ?>&txtFiltro=<?php echo $txtFiltro; ?>">&raquo;</a>
            </li>
        </ul>
    </div>
</div>

<?php include('./templates/pie.php'); ?>